<?php
//--------------------------------------------------------------------
// SocialButton Plugin for rNote
// Copyright by Sakura Mizuki All rights reserved.
// http://www.angel-teatime.com/
//--------------------------------------------------------------------

/*===============================================

 このプラグインはrNoteにTwitterでつぶやくとはてなブックマークボタンを表示させるためのものです。

 ～ 導入方法 ～

 このPHPスクリプトsocial_button.phpを
 rnote.phpと同じフォルダに存在するpluginsフォルダへアップロードしてください。
 また添付しているtwitter.png、b_entry.gifを記事で使用する画像フォルダ(例:/img)に格納してください。
 ※/img以外に格納している場合は75行目の画像格納パス(/img/twitter.png、/img/b_entry.gif)を変更します。

 次に記事ページスキンファイルにTwitterでつぶやくとはてなブックマークボタンを実装します。
 entriesフォルダ内のhtml_item.skinファイルをテキストエディタで開いて以下のコードを書き加えてください。

 記事ページスキンファイルを改造していなければ7行目に
 <div class="category">[<%=$Category%>]</div>
 という行がありますので、この行を以下のように書き換えます。

 --------変更するコードここから--------
 <div class="category"><%=$plugin name="social_button" opt="<%=$Title%>,<%=$Url%>" %> [<%=$Category%>]</div>
 --------変更するコードここまで--------

 次にツッコミスキンファイルにTwitterでつぶやくとはてなブックマークボタンを実装します。
 entriesフォルダ内のwriteback.skinファイルをテキストエディタで開いて以下のコードを書き加えてください。

 記事ページスキンファイルを改造していなければ128行目に
 <p class="url">この記事のリンク用URL＆トラックバックURL : <a href="<%=$Url fullpath="1" %>"><%=$Url fullpath="1" %></a></p>
 という行がありますので、この行を以下のように書き換えます。

 --------変更するコードここから--------
 <p class="url"><%=$plugin name="social_button" opt="<%=$Title%>,<%=$Url%>" %> この記事のリンク用URL＆トラックバックURL : <a href="<%=$Url fullpath="1" %>"><%=$Url fullpath="1" %></a></p>
 --------変更するコードここまで--------

 最後に書き換えたスキンファイルをアップロードしてrnoteadmin.phpの管理画面から再構築を実行すると、
 記事ページのカテゴリ横とコメント書き込みを許可している記事のリンクにTwitterでつぶやく、このエントリーを
 含むはてなブックマークボタンが追加されます。

 ～ 注意 ～

 このSocialButton Plugin for rNoteはある程度PHPのプログラムになれた私が書いていますが
 おかしな動作をすることがある可能性もないわけではないのでプラグインの利用は自己責任で
 よろしくお願いします。

 またURLと画像を入れ替えればWeb拍手やFacebookなどのボタン追加も出来ると思いますので
 自由に改変して利用・再配布してかまいません。

 著作権表記は消さず下に追加で著作権表記の追記をお願い致します。
 ライセンスはZlibライセンスを適用させていただいております。

 質問・再配布に関しては
 http://www.angel-teatime.com/ のサイドメニューにある Contact Meの
 メールフォームからお願いします。

 ～ 更新履歴 ～

 2012/07/29 SocialButton Plugin for rNote Ver.0.1.3
 タイトルに&amp;がある場合正しくツイートできない問題を修正

 2012/06/04 SocialButton Plugin for rNote Ver.0.1.2
 タイトルに&や+などが入ったタイトルの場合正しくツイートできない問題を修正

 2011/08/12 SocialButton Plugin for rNote Ver.0.1.1
 ツッコミスキンの書き換えの説明を追加

 2011/07/30 SocialButton Plugin for rNote Ver.0.1.0
 初版公開

===============================================*/

class social_button{
	// Twitter/はてなブックマークに投げるURLとタイトル(Twitterのみ)を取得する
	function get_url($opt_str){
		// 記事のURL、タイトルを取得する
		$tmp = explode(",", $opt_str);

		// URLを生成する
		$url = substr(SITE_URL, 0, strlen(SITE_URL) - 1).$tmp[1];

		// タイトルに&amp;がある場合はamp;を取り除く
		if(preg_match('/&amp;/', $tmp[0])){
			$tstr = str_replace('&amp;', '&', $tmp[0]);
		}
		else{
			$tstr = $tmp[0];
		}

		// タイトルをエンコードする
		$title = urlencode("◆".$tstr);

		// p_url配列に格納する
		$p_url = array($title, $url);

		return $p_url;
	}

	function exec($opt){
		// 記事のURLとタイトルを取得する(タイトルを利用するのはTwitterのみ)
		$url_array = $this->get_url($opt);

		// Twitter/はてなブックマークのURLを出力する
		return sprintf("%s","<a href=\"http://twitter.com/home?status=".$url_array[0]." - ".$url_array[1]."\" target=\"_blank\"><img src=\"img/twitter.png\" border=\"0\" alt=\"ツイートする\" title=\"ツイートする\"></a> <a href=\"http://b.hatena.ne.jp/entry/".$url_array[1]."\" target=\"_blank\"><img src=\"img/b_entry.gif\" border=\"0\" alt=\"このエントリーを含むはてなブックマーク\" title=\"このエントリーを含むはてなブックマーク\"></a>");
	}
}

?>
